/*
	mapping_output.c
	
	Released under GPL - see the 'COPYING' file   
	
	Copyright (C) 2006 Timo Lassmann <timolassmann@gmail.com>
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    
	Please send bug reports, comments etc. to:
	timolassmann@gmail.com
*/

#include "ngs_toolkit.h"
#include "mapping_output.h"

void mapping_output(struct suffix_pos* sp,const struct fasta* t,struct query* q,const char* mod_line,const int format)
{
	int i,j;
	//float score = 0.0;
	char* q_name;
	char sn[MAX_LINE];
	if(!q->sn){
		sprintf(sn,"%s_%0.0f",q->seq,q->count);
		q_name = sn;
	}else{
		q_name = q->sn;
	}
	const int len = q->len;
	/*switch(format){
		case 1:
			for(i = sp->s_p+1;i <= sp->e_p; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				//print_blast8(q_name,t_name,100,len,sp->mis,sp->indel,suffix[i],suffix[i]+len-1);
				fprintf(foutfile,"%s	%s	%0.2f	%d	%d	%d	%d	%d	%d	%d	%f	%f\n",q_name,t->sn[j],100.0,len,sp->mis,sp->indel,1,len,t->suffix[i]-t->s_index[j],t->suffix[i]+len-1-t->s_index[j],0.0,0.0);
			}
			for(i = sp->s_m+1;i <= sp->e_m; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				//print_blast8(q_name,t_name,100,len,sp->mis,sp->indel,suffix[i]+len-1,suffix[i]);
				fprintf(foutfile,"%s	%s	%0.2f	%d	%d	%d	%d	%d	%d	%d	%f	%f\n",q_name,t->sn[j],100.0,len,sp->mis,sp->indel,1,len,t->suffix[i]+len-1-t->s_index[j],t->suffix[i]-t->s_index[j],0.0,0.0);
			}
			break;
		case 2:
			fprintf(foutfile,"# NGS 1 [");
			print_date();
			fprintf(foutfile,"]\n");
			fprintf(foutfile,"# Query: %s\n",q_name);
			fprintf(foutfile,"# Database: %s\n","GAGA");
			fprintf(foutfile,"# Fields: Query id, Subject id, %% identity, alignment length, mismatches, gap openings, q. start, q. end, s. start, s. end, e-value, bit score\n");
			for(i = sp->s_p+1;i <= sp->e_p; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				//print_blast8(q_name,t_name,100,len,sp->mis,sp->indel,suffix[i],suffix[i]+len-1);
				fprintf(foutfile,"%s	%s	%0.2f	%d	%d	%d	%d	%d	%d	%d	%f	%f\n",q_name,t->sn[j],100.0,len,sp->mis,sp->indel,1,len,t->suffix[i]-t->s_index[j],t->suffix[i]+len-1-t->s_index[j],0.0,0.0);
			}
			for(i = sp->s_m+1;i <= sp->e_m; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				//print_blast8(q_name,t_name,100,len,sp->mis,sp->indel,suffix[i]+len-1,suffix[i]);
				fprintf(foutfile,"%s	%s	%0.2f	%d	%d	%d	%d	%d	%d	%d	%f	%f\n",q_name,t->sn[j],100.0,len,sp->mis,sp->indel,1,len,t->suffix[i]+len-1-t->s_index[j],t->suffix[i]-t->s_index[j],0.0,0.0);
			}
			break;
		case 3:
			//Fields are: <seqname> <source> <feature> <start> <end> <score> <strand> <frame> [attributes] [comments]
			score = ((float)len-((float) (sp->indel + sp->mis)))/(float)len * 100.0;
			for(i = sp->s_p+1;i <= sp->e_p; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				fprintf(foutfile,"%s	nexalign	%s	%d	%d	%0.2f	+\n",t->sn[j],q_name,t->suffix[i]-t->s_index[j],t->suffix[i]+len-1-t->s_index[j],score);
			}
			for(i = sp->s_m+1;i <= sp->e_m; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				fprintf(foutfile,"%s	nexalign	%s	%d	%d	%0.2f	-\n",t->sn[j],q_name,t->suffix[i]-t->s_index[j],t->suffix[i]+len-1-t->s_index[j],score);
			}
			break;
		default:*/
			for(i = sp->s_p+1;i <= sp->e_p; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				fprintf(foutfile,"%s	%s	+	%d	%d	%s\n",q_name,t->sn[j],t->suffix[i]-t->s_index[j]-1,t->suffix[i]+len-1-t->s_index[j],mod_line);
			}
			for(i = sp->s_m+1;i <= sp->e_m; i++){
				j = arbins(t->s_index,t->numseq,t->suffix[i]);
				fprintf(foutfile,"%s	%s	-	%d	%d	%s\n",q_name,t->sn[j],t->suffix[i]-t->s_index[j]-1,t->suffix[i]+len-1-t->s_index[j],mod_line);
			}/*
			break;
	}*/
}
